JUCE: RangedAudioParameter Class Reference

JUCE

Public Member Functions | List of all members
RangedAudioParameter Class Referenceabstract
juce_audio_processors » utilities

This abstract base class is used by some AudioProcessorParameter helper classes. More...

`#include <juce_RangedAudioParameter.h>`

Inheritance diagram for RangedAudioParameter:

## Public Member Functions
| RangedAudioParameter (const String &parameterID, const String &parameterName, const String &parameterLabel={}, Category parameterCategory=AudioProcessorParameter::genericParameter)
| The creation of this object requires providing a name and ID which will be constant for its lifetime. More...
virtual const NormalisableRange< float > & | getNormalisableRange () const =0
| Returns the range of values that the parameter can take. More...
int | getNumSteps () const override
| Returns the number of steps for this parameter based on the normalisable range's interval. More...
float | convertTo0to1 (float v) const noexcept
| Normalises and snaps a value based on the normalisable range. More...
float | convertFrom0to1 (float v) const noexcept
| Denormalises and snaps a value based on the normalisable range. More...
Public Member Functions inherited from AudioProcessorParameterWithID
| AudioProcessorParameterWithID (const String &parameterID, const String &parameterName, const String &parameterLabel={}, Category parameterCategory=AudioProcessorParameter::genericParameter)
| The creation of this object requires providing a name and ID which will be constant for its lifetime. More...
| ~AudioProcessorParameterWithID () override
| Destructor. More...
String | getName (int) const override
| Returns the name to display for this parameter, which should be made to fit within the given string length. More...
String | getLabel () const override
| Some parameters may be able to return a label string for their units. More...
Category | getCategory () const override
| Returns the parameter's category. More...
String | getParameterID () const override
| Returns an ID that is unique to this parameter. More...
virtual String | getParameterID () const =0
| Returns an ID that is unique to this parameter. More...
Public Member Functions inherited from AudioProcessorParameter
| AudioProcessorParameter () noexcept
virtual | ~AudioProcessorParameter ()
| Destructor. More...
virtual float | getValue () const =0
| Called by the host to find out the value of this parameter. More...
virtual void | setValue (float newValue)=0
| The host will call this method to change the value of a parameter. More...
void | setValueNotifyingHost (float newValue)
| A processor should call this when it needs to change one of its parameters. More...
void | beginChangeGesture ()
| Sends a signal to the host to tell it that the user is about to start changing this parameter. More...
void | endChangeGesture ()
| Tells the host that the user has finished changing this parameter. More...
virtual float | getDefaultValue () const =0
| This should return the default value for this parameter. More...
virtual String | getName (int maximumStringLength) const =0
| Returns the name to display for this parameter, which should be made to fit within the given string length. More...
virtual String | getLabel () const =0
| Some parameters may be able to return a label string for their units. More...
virtual int | getNumSteps () const
| Returns the number of steps that this parameter's range should be quantised into. More...
virtual bool | isDiscrete () const
| Returns whether the parameter uses discrete values, based on the result of getNumSteps, or allows the host to select values continuously. More...
virtual bool | isBoolean () const
| Returns whether the parameter represents a boolean switch, typically with "On" and "Off" states. More...
virtual String | getText (float normalisedValue, int) const
| Returns a textual version of the supplied normalised parameter value. More...
virtual float | getValueForText (const String &text) const =0
| Should parse a string and return the appropriate value for it. More...
virtual bool | isOrientationInverted () const
| This can be overridden to tell the host that this parameter operates in the reverse direction. More...
virtual bool | isAutomatable () const
| Returns true if the host can automate this parameter. More...
virtual bool | isMetaParameter () const
| Should return true if this parameter is a "meta" parameter. More...
virtual Category | getCategory () const
| Returns the parameter's category. More...
int | getParameterIndex () const noexcept
| Returns the index of this parameter in its parent processor's parameter list. More...
virtual String | getCurrentValueAsText () const
| Returns the current value of the parameter as a String. More...
virtual StringArray | getAllValueStrings () const
| Returns the set of strings which represent the possible states a parameter can be in. More...
void | addListener (Listener *newListener)
| Registers a listener to receive events when the parameter's state changes. More...
void | removeListener (Listener *listener)
| Removes a previously registered parameter listener. More...
void | sendValueChangedMessageToListeners (float newValue)

## Additional Inherited Members
Public Types inherited from AudioProcessorParameter
enum | Category { genericParameter = (0 << 16) | 0 , inputGain = (1 << 16) | 0 , outputGain = (1 << 16) | 1 , inputMeter = (2 << 16) | 0 , outputMeter = (2 << 16) | 1 , compressorLimiterGainReductionMeter = (2 << 16) | 2 , expanderGateGainReductionMeter = (2 << 16) | 3 , analysisMeter = (2 << 16) | 4 , otherMeter = (2 << 16) | 5 }
Public Attributes inherited from AudioProcessorParameterWithID
const String | paramID
| Provides access to the parameter's ID string. More...
const String | name
| Provides access to the parameter's name. More...
const String | label
| Provides access to the parameter's label. More...
const Category | category
| Provides access to the parameter's category. More...

## Detailed Description

This abstract base class is used by some AudioProcessorParameter helper classes.

See also
  AudioParameterFloat, AudioParameterInt, AudioParameterBool, AudioParameterChoice

## Constructor & Destructor Documentation

## ◆ RangedAudioParameter()

RangedAudioParameter::RangedAudioParameter | ( | const String & | parameterID,
|  | const String & | parameterName,
|  | const String & | parameterLabel = `{}`,
|  | Category | parameterCategory = `AudioProcessorParameter::genericParameter`
| ) |  |

The creation of this object requires providing a name and ID which will be constant for its lifetime.

## Member Function Documentation

## ◆ getNormalisableRange()

virtual const NormalisableRange< float > & RangedAudioParameter::getNormalisableRange | ( |  | ) | const
| pure virtual

Returns the range of values that the parameter can take.

Implemented in AudioParameterBool, AudioParameterChoice, AudioParameterFloat, and AudioParameterInt.

Referenced by AudioParameterInt::getRange().

## ◆ getNumSteps()

int RangedAudioParameter::getNumSteps | ( |  | ) | const
| overridevirtual

Returns the number of steps for this parameter based on the normalisable range's interval.

If you are using lambda functions to define the normalisable range's snapping behaviour then you should override this function so that it returns the number of snapping points.

Reimplemented from AudioProcessorParameter.

## ◆ convertTo0to1()

float RangedAudioParameter::convertTo0to1 | ( | float | v | ) | const
| noexcept

Normalises and snaps a value based on the normalisable range.

## ◆ convertFrom0to1()

float RangedAudioParameter::convertFrom0to1 | ( | float | v | ) | const
| noexcept

Denormalises and snaps a value based on the normalisable range.

The documentation for this class was generated from the following file:

- juce_RangedAudioParameter.h